if(typeof $ == "undefined") {
	alert('JQuery not loaded');
}

/**
 * Obsługa chmurek
 */ 

$(document).ready(function(){
	$( ".cloud" ).draggable({ 
		containment: "#clipper", 
		//containment: "body",
		scroll: false, 
		opacity: 0.60  
	});
	$( ".cloud-placer" ).droppable({
		accept: '.cloud',
		tolerance: 'pointer',
		activeClass: "cloud-active",
		hoverClass: "cloud-hover",
		drop: function( event, ui ) {
			var id = $(this).data('cloud-id');
			if( typeof(id) != 'undefined' || id != '' ) {
				$('.cloud[data-cloud-id='+id+']').show();
				$('.cloud[data-cloud-id='+id+']').css('left','');
				$('.cloud[data-cloud-id='+id+']').css('top','');
			}
			$(this).data('cloud-id', ui.draggable.data('cloud-id'));
			$(this).addClass('filled');
			$(this).text(ui.draggable.text());
			ui.draggable.hide();
		 }
	});
	$( ".cloud-group" ).droppable({
		accept: '.cloud',
		tolerance: 'pointer',
		activeClass: "cloud-active",
		hoverClass: "cloud-hover",
		drop: function( event, ui ) {
			$(this).children('.cloud-group-placer').append('<div class="cloud-placed" data-cloud-id="'+ui.draggable.data('cloud-id')+'">'+ui.draggable.text()+'</div>');
			ui.draggable.hide();			
		 }
	});
	$('.cloud-placed').live('click', function() {
		var id = $(this).data('cloud-id');
		$('.cloud[data-cloud-id='+id+']').show();
		$('.cloud[data-cloud-id='+id+']').css('left','');
		$('.cloud[data-cloud-id='+id+']').css('top','');
		$(this).remove();
	});
	$( ".clouds-home" ).droppable({
		accept: '.cloud',
		activeClass: "cloud-active",
		hoverClass: "cloud-hover",
		drop: function( event, ui ) {
			ui.draggable.css('left','');
			ui.draggable.css('top','');
		 }
	});
	$('.filled').live('mousedown', function() {
		var id = $(this).data('cloud-id');
		if( typeof(id) != 'undefined' ) {
			$('.cloud[data-cloud-id='+id+']').show();
			$('.cloud[data-cloud-id='+id+']').css('left','');
			$('.cloud[data-cloud-id='+id+']').css('top','');
		}
		$(this).text('');
		$(this).data('cloud-id', '');
		$(this).removeClass('filled');
	});
});

/**
 * Obsługa checkboxów
 */

$(document).ready(function(){
	$('.check-line').click(function(){
		var ch = $(this).data('checked');
	
		if( !ch ){
			$(this).children('span.checker').removeClass('icon-check-empty').addClass('icon-check');
			$(this).data('checked', 1);
		}else{
			$(this).children('span.checker').removeClass('icon-check').addClass('icon-check-empty');
			$(this).data('checked', 0);
		}
		
	});
});

/**
 * Obsługa par
 */

function dontForceHeight() {
	$('.slide .order-list li').each(function() {
		$(this).height('');
	});
}

function refreshOrders() {
	dontForceHeight();
	resizeSortables(
			$('.slide:visible .column-left .order-list'),
			null,
			$('.slide:visible .column-right .order-list')
		);
}

function resizeSortables(sortable, draggedItem, sortableOther) {
	dontForceHeight();
	
	var sortLi    = sortable.children('li:not(.ui-sortable-helper)'),
		sortOthLi = sortableOther.children('li:not(.ui-sortable-helper)');
	
	var len = Math.min(sortLi.length, sortOthLi.length);

	for(var i = 0; i < len; i++) {
		if(draggedItem != null && $(sortLi[i]).hasClass('list-order-placeholder')) {

			var h1 = draggedItem.height();
			var h2 = $(sortOthLi[i]).height();

			var height = Math.max(h1,h2);
			
			$(sortLi[i]).height(height);
			$(sortOthLi[i]).height(height);
			draggedItem.height(height);
		} else {
			var h1 = $(sortLi[i]).height();
			var h2 = $(sortOthLi[i]).height();
			
			var height = Math.max(h1,h2);
			$(sortLi[i]).height(height);
			$(sortOthLi[i]).height(height);
		}
	}
}

function applySortabilityLeft(slide, left) {
	$(slide).find( ".column-left .order-list" ).sortable({
		placeholder: "list-order-placeholder",
		axis: "y",	
		tolerance: 'pointer',
		sort: function( event, ui ) {
			resizeSortables(
					$(slide).find( ".column-right .order-list" ),
					ui.item,
					$(slide).find( ".column-left .order-list" )
					);
		},
		stop: function( event, ui ) {
			resizeSortables(
					$(slide).find( ".column-right .order-list" ),
					null,
					$(slide).find( ".column-left .order-list" )
					);
		}
	});
}

function applySortabilityRight(slide) {
	
	$(slide).find( ".column-right .order-list" ).sortable({
		placeholder: "list-order-placeholder",
		axis: "y",	
		tolerance: 'pointer',
		sort: function( event, ui ) {
			resizeSortables(
					$(slide).find( ".column-left .order-list" ),
					ui.item,
					$(slide).find( ".column-right .order-list" )
					);
		},
		stop: function( event, ui ) {
			resizeSortables(
					$(slide).find( ".column-left .order-list" ),
					null,
					$(slide).find( ".column-right .order-list" )
					);
		}
	});
}

$(document).ready(function() {
	$('.slide[data-slide-type=pairs]').each(function() {
		var slide = this;
		applySortabilityLeft(slide);
		applySortabilityRight(slide);

		setTimeout(refreshOrders, 1);
	});
	
	$('.slide[data-slide-type=pairsimage]').each(function() {
		var slide = this;
		applySortabilityRight(slide);

		setTimeout(refreshOrders, 1);
	});
	
});

/**
 * 
 */

var width, height;

var BASEFONT = 18;

var slideDescriptors = [];
var slideIndex = 0;

function changeWindowSizeEvent() {
	var ratio = null;
	
	if($('body').data('slideshow-ratio') != null)
		ratio = parseFloat($('body').data('slideshow-ratio'));
	
	if(isNaN(ratio) || typeof(ratio) != 'number') {
		ratio = 4/3;
	}
	
	height = $('body').height();
	width = height * ratio;

	if(width > $('body').width()) {
		width = $('body').width();
		height = width / ratio;
	}

	$('#clipper').width(width);
	$('#clipper').height(height);

	$('body').css('font-size', BASEFONT * width / 800 + 'px');
	
	setTimeout(refreshOrders, 1);
}

/*
 * Obsługa slide'ów
 */

function initSlides() {
	tmp = [];
	$('#clipper .slide').each(function(index){
		id = $(this).data('slide-id');
		tmp[id] = this;
	});
	keys = Object.keys(tmp).sort();
	for(var i=0; i<keys.length;i++) {
		slideDescriptors[i] = tmp[keys[i]];
	}
	
	$('.page_count').html(keys.length);
	if(keys.length == 0) {
		$('#pages').hide();
	}
	
	if(slideDescriptors.length==0 || typeof(slideDescriptors[0])=='undefinied') {
		$('#no-slide').show();
		$('#end-slide').show();
	}
	slideIndex = 0;
	$('#clipper .slide').hide();
	$(slideDescriptors[0]).show();
	toggleNavigation();
}

function showSlide(index) {
	if(typeof(slideDescriptors[index])=='undefined') return;	
	
	$('.page_num').html(index+1);
	
	if(slideIndex==index) return;
	$(slideDescriptors[slideIndex]).fadeOut();
	$(slideDescriptors[index]).fadeIn();
	slideIndex = index;
	
	if($(slideDescriptors[index]).data('slide-show-correct')){
		$('.correctness').show();
	}else{
		$('.correctness').hide();
	}
	
	toggleNavigation();
	
	setTimeout(refreshOrders, 500);
}

function toggleNavigation() {
	$('#prev-slide, #next-slide').removeClass('hidden');
	if(slideIndex == 0) {
		$('#prev-slide').addClass('hidden');
	} 
	if(slideIndex == slideDescriptors.length - 1) {
		$('#next-slide').addClass('hidden');
	}
}

function prevSlideEvent(event) {

	if(event){
		 event.preventDefault();
	}
	
	if(slideIndex <= 0) return;
	
	showSlide(slideIndex-1);
}

	
function nextSlideEvent(event) {
	if(event){
		event.preventDefault();
	}
	
	if(slideIndex >= slideDescriptors.length-1) return;
	
	showSlide(slideIndex+1);
}

	
function keypressSlideEvent(event) {

	if( event.target.localName != "body" ){
		return true;
	}
	
	if(event.which==0&&event.keyCode==37) { 
		// left arrow
		prevSlideEvent();
	} else if(event.which==0&&event.keyCode==39) { 
		// right arrow
		nextSlideEvent();
	} else if(event.which==32&&event.keyCode==0) { 
		// spacebar
		nextSlideEvent();
	}
}

$(document).ready(function(){	
	$(window).resize(changeWindowSizeEvent);
	changeWindowSizeEvent();
	initSlides();
	
	showSlide(0);
	
	$('#prev-slide').click(prevSlideEvent);
	$('#next-slide').click(nextSlideEvent);

	$(document).keypress(keypressSlideEvent);
});